/**
 * oscP5message by andreas schlegel
 * example shows how to create osc messages.
 * oscP5 website at http://www.sojamo.de/oscP5
 */
 
import oscP5.*;
import netP5.*;

OscP5 oscP5;
NetAddress myRemoteLocation;

void setup() {
  size(400,400);
  frameRate(25);
  /* start oscP5, listening for incoming messages at port 12000 */
  oscP5 = new OscP5(this,5555);
  
  /* myRemoteLocation is a NetAddress. a NetAddress takes 2 parameters,
   * an ip address and a port number. myRemoteLocation is used as parameter in
   * oscP5.send() when sending osc packets to another computer, device, 
   * application. usage see below. for testing purposes the listening port
   * and the port of the remote location address are the same, hence you will
   * send messages back to this sketch.
   */
  myRemoteLocation = new NetAddress("127.0.0.1",5555);
}


void draw() {
  background(0);  
}

void mousePressed() {
  /* in the following different ways of creating osc messages are shown by example */
  OscMessage myMessage = new OscMessage( "processing" );
  
  
 // myMessage.add(new int[] {1,2,3,4}); /* add an int array to the osc message */
  myMessage.add(new int[] { 1, 158, 163, 166,
                            1, 300, 300, 5, 5,
                            2, 400, 280, 5, 5,
                            3, 450, 240, 5, 5,
                            4, 450, 240, 5, 5,
                            5, 200, 280, 5, 5,
                            6, 450, 240, 5, 5,
                            7, 450, 240, 5, 5,
                            8, 450, 240, 5, 5,
                            9, 450, 240, 5, 5,
                            10, 450, 240, 5, 5,
                            11, 450, 240, 5, 5,
                            12, 200, 280, 5, 5,
                            13, 600, 250, 5, 5,
                            14, 200, 280, 5, 5,
                            15, 1000, 300, 5, 5,
                            16, 200, 280, 5, 5,
                            17, 1000, 300, 5, 5,
                            18, 1000, 300, 5, 5,
                            19, 1000, 300, 5, 5,
                            20, 1250, 200, 5, 5,
                            21, 1450, 300, 5, 5,
                            22, 1000, 300, 5, 5,
                            23, 800, 300, 5, 6,
                            24, 1350, 180, 5, 5,
                            25, 1250, 200, 5, 5,
                            26, 1350, 180, 5, 5,
                            27, 1250, 200, 5, 5,
                            28, 1350, 180, 5, 5,
                            29, 1250, 200, 5, 5,
                            30, 1350, 180, 5, 5,
                            31, 1250, 200, 5, 5,
                            32, 1350, 180, 5, 5,
                            33, 1250, 200, 5, 5,
                            34, 1350, 180, 5, 5,
                            35, 1250, 200, 5, 5,
                            36, 1350, 180, 5, 5,
                            37, 1000, 300, 5, 5,
                            38, 800, 300, 5, 6,
                            39, 1350, 180, 5, 5,
                            40, 450, 240, 5, 5,
                            41, 450, 240, 5, 5,
                            42, 200, 280, 5, 5,
                            43, 600, 250, 5, 5,
                            44, 200, 280, 5, 5,
                            45, 1000, 300, 5, 5,
                            46, 200, 280, 5, 5,
                            47, 1000, 300, 5, 5,
                            48, 1000, 300, 5, 5,
                            49, 1000, 300, 5, 5,
                            50, 450, 240, 5, 5,
                            51, 450, 240, 5, 5,
                            52, 200, 280, 5, 5,
                            53, 600, 250, 5, 5,
                            54, 200, 280, 5, 5,
                            55, 1000, 300, 5, 5,
                            56, 200, 280, 5, 5,
                            57, 1000, 300, 5, 5,
                            58, 1000, 300, 5, 5,
                            59, 1000, 300, 5, 5,
                          }); 

  /* send the message */
  oscP5.send(myMessage, myRemoteLocation); 
}


/* incoming osc message are forwarded to the oscEvent method. */
void oscEvent(OscMessage theOscMessage) {
  /* print the address pattern and the typetag of the received OscMessage */
  print("### received an osc message.");
  print(" addrpattern: "+theOscMessage.addrPattern());
  println(" typetag: "+theOscMessage.typetag());
}
